Index: uspace/lib/net/netif/netif_remote.c
===================================================================
--- uspace/lib/net/netif/netif_remote.c	(revision 995689d125f7f186bf072db2d8270c513856a969)
+++ uspace/lib/net/netif/netif_remote.c	(revision 404dbaecf9ad92b9da256083dcfe665a558b4f99)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup netif
+/** @addtogroup libnet 
  * @{
  */
@@ -35,4 +35,8 @@
  */
 
+#include <netif_remote.h>
+#include <packet_client.h>
+#include <generic.h>
+
 #include <ipc/services.h>
 #include <ipc/netif.h>
@@ -41,9 +45,18 @@
 #include <adt/measured_strings.h>
 #include <net/packet.h>
-#include <packet_client.h>
 #include <net/device.h>
-#include <netif_remote.h>
-#include <generic.h>
 
+/** Return the device local hardware address.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @param[out] address	The device local hardware address.
+ * @param[out] data	The address data.
+ * @return		EOK on success.
+ * @return		EBADMEM if the address parameter is NULL.
+ * @return		ENOENT if there no such device.
+ * @return		Other error codes as defined for the
+ *			netif_get_addr_message() function.
+ */
 int netif_get_addr_req_remote(int netif_phone, device_id_t device_id,
     measured_string_ref *address, char **data)
@@ -53,10 +66,32 @@
 }
 
-int netif_probe_req_remote(int netif_phone, device_id_t device_id, int irq, int io)
+/** Probe the existence of the device.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @param[in] irq	The device interrupt number.
+ * @param[in] io	The device input/output address.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the
+ *			netif_probe_message().
+ */
+int
+netif_probe_req_remote(int netif_phone, device_id_t device_id, int irq, int io)
 {
 	return async_req_3_0(netif_phone, NET_NETIF_PROBE, device_id, irq, io);
 }
 
-int netif_send_msg_remote(int netif_phone, device_id_t device_id, packet_t packet,
+/** Send the packet queue.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @param[in] packet	The packet queue.
+ * @param[in] sender	The sending module service.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the generic_send_msg()
+ *			function.
+ */
+int
+netif_send_msg_remote(int netif_phone, device_id_t device_id, packet_t packet,
     services_t sender)
 {
@@ -65,4 +100,14 @@
 }
 
+/** Start the device.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the find_device()
+ *			function.
+ * @return		Other error codes as defined for the
+ *			netif_start_message() function.
+ */
 int netif_start_req_remote(int netif_phone, device_id_t device_id)
 {
@@ -70,4 +115,14 @@
 }
 
+/** Stop the device.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the find_device()
+ *			function.
+ * @return		Other error codes as defined for the
+ *			netif_stop_message() function.
+ */
 int netif_stop_req_remote(int netif_phone, device_id_t device_id)
 {
@@ -75,4 +130,11 @@
 }
 
+/** Return the device usage statistics.
+ *
+ * @param[in] netif_phone The network interface phone.
+ * @param[in] device_id	The device identifier.
+ * @param[out] stats	The device usage statistics.
+ * @return EOK on success.
+ */
 int netif_stats_req_remote(int netif_phone, device_id_t device_id,
     device_stats_ref stats)
@@ -99,11 +161,12 @@
  * @param[in] receiver  The message receiver.
  *
- * @return The phone of the needed service.
- * @return EOK on success.
- * @return Other error codes as defined for the bind_service() function.
- *
+ * @return		The phone of the needed service.
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the bind_service()
+ *			function.
  */
-int netif_bind_service_remote(services_t service, device_id_t device_id, services_t me,
-    async_client_conn_t receiver)
+int
+netif_bind_service_remote(services_t service, device_id_t device_id,
+    services_t me, async_client_conn_t receiver)
 {
 	return bind_service(service, device_id, me, 0, receiver);