Index: uspace/lib/pcap/src/pcap.c
===================================================================
--- uspace/lib/pcap/src/pcap.c	(revision fb316822bc92404f7ec785477d173721f75b2232)
+++ uspace/lib/pcap/src/pcap.c	(revision 420b13d52f0d0149b0ff50f4b60cc6690842d6f3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Nataliia Korop
+ * Copyright (c) 2024 Nataliia Korop
  * All rights reserved.
  *
@@ -53,6 +53,7 @@
 /** Add pcap file header to the new .pcap file.
  *
- * @param writer writer that has destination buffer and ops to write to destination buffer.
- *
+ * @param writer 	Writer that has destination buffer and ops to write to destination buffer.
+ * @param linktype 	Linktype for the file header.
+ * @param nano 		True for nanoseconds, false for microseconds in timestamp.
  */
 void pcap_writer_add_header(pcap_writer_t *writer, uint32_t linktype, bool nano)
@@ -69,7 +70,7 @@
 /** Add packet to the .pcap file.
  *
- * @param writer
- * @param captured_packet Packet to be dumped
- * @param size Size of the captured packet
+ * @param writer 			Writer that has destination buffer and ops to write to destination buffer.
+ * @param captured_packet 	Packet to be dumped
+ * @param size 				Size of the captured packet
  *
  */
Index: uspace/lib/pcap/src/pcap_dumper.c
===================================================================
--- uspace/lib/pcap/src/pcap_dumper.c	(revision fb316822bc92404f7ec785477d173721f75b2232)
+++ uspace/lib/pcap/src/pcap_dumper.c	(revision 420b13d52f0d0149b0ff50f4b60cc6690842d6f3)
@@ -30,6 +30,5 @@
  * @{
  */
-/** @file
- *  @brief pcap inteface: Dumping interface for the device which packets we want to dump
+/** @file Pcap dumper. Structure is a part of every device that is in category PCAP and can dump packets.
  */
 
@@ -43,7 +42,7 @@
 /** Initialize writing to .pcap file.
  *
- * @param writer    Interface for working with .pcap file.
+ * @param writer    Interface for writing data.
  * @param filename  Name of the file for dumping packets.
- * @return          EOK on success or an error code.
+ * @return          EOK on success, otherwise an error code.
  *
  */
@@ -66,4 +65,9 @@
 }
 
+/** Open file for appending to the end of it.
+ *  @param writer 	Interface for writing data.
+ *  @param filename Path to the file.
+ *  @return 		EOK on success, error code otherwise.
+ */
 static errno_t pcap_writer_to_file_init_append(pcap_writer_t *writer, const char *filename)
 {
@@ -76,4 +80,9 @@
 }
 
+/** Initialize file for dumping usb packets.
+ *  @param writer 	Interface for writing data.
+ *  @param filename Path to the file.
+ *  @return 		EOK on success, error code otherwise.
+ */
 static errno_t pcap_writer_to_file_usb_init(pcap_writer_t *writer, const char *filename)
 {
@@ -94,4 +103,9 @@
 }
 
+/** Write 4B to the file.
+ *  @param writer 	Interface for writing data.
+ *  @param data 	Bytes to write.
+ *  @return 		Size of successfully witten data.
+ */
 static size_t pcap_file_w32(pcap_writer_t *writer, uint32_t data)
 {
@@ -99,4 +113,9 @@
 }
 
+/** Write 2B to the file.
+ *  @param writer 	Interface for writing data.
+ *  @param data 	Bytes to write.
+ *  @return 		Size of successfully witten data.
+ */
 static size_t pcap_file_w16(pcap_writer_t *writer, uint16_t data)
 {
@@ -104,4 +123,10 @@
 }
 
+/** Write block of bytes to the file.
+ *  @param writer 	Interface for writing data.
+ *  @param data 	Bytes to write.
+ *  @param size		Size of block of bytes.
+ *  @return 		Size of successfully witten data.
+ */
 static size_t pcap_file_wbuffer(pcap_writer_t *writer, const void *data, size_t size)
 {
@@ -110,4 +135,7 @@
 }
 
+/** Close file for writing.
+ *  @param writer 	Interaface for writing data.
+ */
 static void pcap_file_close(pcap_writer_t *writer)
 {
@@ -116,4 +144,10 @@
 }
 
+/** Write <= 60B of block of bytes.
+ *  @param writer 	Interface for writing data.
+ *  @param data 	Bytes to write.
+ *  @param size		Size of block of bytes.
+ *  @return 		Size of successfully witten data.
+ */
 static size_t pcap_short_file_wbuffer(pcap_writer_t *writer, const void *data, size_t size)
 {
@@ -121,4 +155,5 @@
 }
 
+/** Standard writer operations for writing data to a newly created file. */
 static const pcap_writer_ops_t file_ops = {
 	.open = &pcap_writer_to_file_init,
@@ -129,4 +164,5 @@
 };
 
+/** Truncated writer operations. Only first 60 bytes of the packet are written. */
 static const pcap_writer_ops_t short_file_ops = {
 	.open = &pcap_writer_to_file_init,
@@ -138,4 +174,5 @@
 };
 
+/** Append writer operations. Instead of creating new file open existing file and append packets. */
 static const pcap_writer_ops_t append_file_ops = {
 	.open = &pcap_writer_to_file_init_append,
@@ -146,4 +183,5 @@
 };
 
+/** USB writer operations. Writing USB packets to the file. */
 static const pcap_writer_ops_t usb_file_ops = {
 	.open = &pcap_writer_to_file_usb_init,
@@ -154,6 +192,8 @@
 };
 
+/** Default array of operations. Must be consistens with constants in /uspace/app/pcapctl/main.c */
 static pcap_writer_ops_t ops[4] = { file_ops, short_file_ops, append_file_ops, usb_file_ops };
 
+/** Get number of writer operations in @ref ops */
 int pcap_dumper_get_ops_number(void)
 {
@@ -161,4 +201,9 @@
 }
 
+/** Open destination buffer for writing and set flag for dumping.
+ *  @param dumper	Structure responsible for dumping packets. Part of the driver.
+ *  @param name		Name of the destination buffer to dump packets to.
+ *  @return 		EOK if successful, erro code otherwise.
+ */
 errno_t pcap_dumper_start(pcap_dumper_t *dumper, const char *name)
 {
@@ -174,4 +219,9 @@
 }
 
+/** Set writer options for the writer.
+ *  @param dumper 	Structure responsible for dumping packets. Part of the driver.
+ *  @param index	Index of the writer operations from array @ref ops.
+ *  @return 		EOK if successful, erro code otherwise.
+ */
 errno_t pcap_dumper_set_ops(pcap_dumper_t *dumper, int index)
 {
@@ -183,4 +233,9 @@
 }
 
+/** Write packet to destination buffer.
+ *  @param dumper	Structure responsible for dumping packets. Part of the driver.
+ *  @param data		Packet data to write.
+ *  @param size		Size of the packet.
+ */
 void pcap_dumper_add_packet(pcap_dumper_t *dumper, const void *data, size_t size)
 {
@@ -196,4 +251,7 @@
 }
 
+/** Close destination buffer for writing and unset flag for dumping.
+ *  @param dumper	Structure responsible for dumping packets. Part of the driver.
+ */
 void pcap_dumper_stop(pcap_dumper_t *dumper)
 {
Index: uspace/lib/pcap/src/pcapdump_client.c
===================================================================
--- uspace/lib/pcap/src/pcapdump_client.c	(revision fb316822bc92404f7ec785477d173721f75b2232)
+++ uspace/lib/pcap/src/pcapdump_client.c	(revision 420b13d52f0d0149b0ff50f4b60cc6690842d6f3)
@@ -30,6 +30,5 @@
  * @{
  */
-/** @file
- * @brief Client side of the pcapctl. Functions are called from the app pcapctl
+/** @file Client side of the pcapctl. Functions are called from the app pcapctl.
  */
 
@@ -52,4 +51,9 @@
 }
 
+/** Get service based on the index of the device.
+ *  @param index of the device.
+ *  @param svc placeholder for service ide.
+ *  @return EOK if successful, error code otherwise.
+ */
 static errno_t pcapctl_cat_get_svc(int *index, service_id_t *svc)
 {
@@ -80,4 +84,8 @@
 }
 
+/** Check if the index is an index of valid device.
+ *  @param index to check.
+ *  @return EOK if device is valid, error code otherwise.
+ */
 errno_t pcapctl_is_valid_device(int *index)
 {
@@ -105,4 +113,8 @@
 }
 
+/** Check if the index is an index of valid writer operations.
+ * @param index to check.
+ * @param sess 	pcapctl session for IPC communictaion.
+ */
 errno_t pcapctl_is_valid_ops_number(int *index, pcapctl_sess_t *sess)
 {
@@ -127,7 +139,5 @@
 }
 
-/**
- *
- */
+/** Get all devices that can dump packets. */
 errno_t pcapctl_list(void)
 {
@@ -160,6 +170,8 @@
 }
 
-/**
- *
+/** Start pcapctl IPC session.
+ *  @param index 	index of the device which can dump packets.
+ *  @param rsess 	placeholder for the session.
+ *  @return			EOK if successful, error code otherwise.
  */
 errno_t pcapctl_dump_open(int *index, pcapctl_sess_t **rsess)
@@ -196,6 +208,7 @@
 }
 
-/**
- *
+/** Close pcapctl IPC session.
+ *  @param sess Session to close.
+ *  @return EOK if successful, error code otherwise.
  */
 errno_t pcapctl_dump_close(pcapctl_sess_t *sess)
@@ -205,9 +218,9 @@
 }
 
-/** Starting a new session for pcapctl
- *
- * @param name Name of the file to dump packets to
- * @param sess session to start
- * @return EOK on success or an error code
+/** Send start request via IPC to start dumping.
+ *
+ * @param name 	Name of the destination buffer to dump packets to.
+ * @param sess 	Session that is used for communication.
+ * @return 		EOK on success or an error code.
  */
 errno_t pcapctl_dump_start(const char *name, int *ops_index, pcapctl_sess_t *sess)
@@ -233,8 +246,8 @@
 }
 
-/** Finish current session for pcapctl
- *
- * @param sess Session to finish
- * @return EOK on success or an error code
+/** Send stop request via IPC to start dumping.
+ *
+ * @param sess 	Session that is used for communication.
+ * @return 		EOK on success or an error code.
  */
 errno_t pcapctl_dump_stop(pcapctl_sess_t *sess)
Index: uspace/lib/pcap/src/pcapdump_drv_iface.c
===================================================================
--- uspace/lib/pcap/src/pcapdump_drv_iface.c	(revision fb316822bc92404f7ec785477d173721f75b2232)
+++ uspace/lib/pcap/src/pcapdump_drv_iface.c	(revision 420b13d52f0d0149b0ff50f4b60cc6690842d6f3)
@@ -48,8 +48,7 @@
 #define NAME "pcap"
 
-/** Initialize interface for dumping packets
- *
- * @param dumper Device dumping interface
- *
+/** Initialize interface for dumping packets.
+ * @param dumper 	Device dumping interface.
+ * @return 			EOK if successful, error code otherwise.
  */
 static errno_t pcapdump_drv_dumper_init(pcap_dumper_t *dumper)
@@ -67,4 +66,8 @@
 }
 
+/** Initialize driver dumping functionality.
+ *  @param dumper 	Dumping interface of the driver.
+ * 	@return 		EOK if successful, error code otherwise.
+ */
 errno_t pcapdump_init(pcap_dumper_t *dumper)
 {
@@ -86,11 +89,11 @@
 }
 
-/** Dumping function for driver
+/** Dumping function for driver.
  *
- * Called every time, the packet is sent/recieved by the device
+ * Called every time, the packet is sent/recieved by the device.
  *
- * @param dumper Dumping interface
- * @param data The packet
- * @param size Size of the packet
+ * @param dumper 	Dumping interface.
+ * @param data 		The packet
+ * @param size 		Size of the packet.
  *
  */
Index: uspace/lib/pcap/src/pcapdump_srv.c
===================================================================
--- uspace/lib/pcap/src/pcapdump_srv.c	(revision fb316822bc92404f7ec785477d173721f75b2232)
+++ uspace/lib/pcap/src/pcapdump_srv.c	(revision 420b13d52f0d0149b0ff50f4b60cc6690842d6f3)
@@ -47,4 +47,8 @@
 #include "pcapdump_ipc.h"
 
+/** Start dumping.
+ * 	@param icall 	IPC call with request to start.
+ *  @param dumper 	Dumping interface of the driver.
+ */
 static void pcapdump_start_srv(ipc_call_t *icall, pcap_dumper_t *dumper)
 {
@@ -84,4 +88,8 @@
 }
 
+/** Stop dumping
+ * 	@param icall 	IPC call with request to stop.
+ *  @param dumper 	Dumping interface of the driver.
+ */
 static void pcapdump_stop_srv(ipc_call_t *icall, pcap_dumper_t *dumper)
 {
@@ -90,4 +98,7 @@
 }
 
+/** Get number of accessibke writer operations.
+ * 	@param icall 	IPC call with request to get number of accessible writer operations.
+ */
 static void pcapdump_get_ops_num_srv(ipc_call_t *icall)
 {
@@ -99,4 +110,8 @@
 }
 
+/** Callback connection function. Accepts requests and processes them.
+ * 	@param icall 	IPC call with request.
+ *  @param arg	 	Dumping interface of the driver.
+ */
 void pcapdump_conn(ipc_call_t *icall, void *arg)
 {